package cert_manager

// Code generated by http://github.com/gojuno/minimock (3.0.6). DO NOT EDIT.

//go:generate minimock -i github.com/rekby/lets-proxy2/internal/cache.Value -o ./value_mock_test.go

import (
	"context"
	"sync"
	mm_atomic "sync/atomic"
	mm_time "time"

	"github.com/gojuno/minimock/v3"
)

// ValueMock implements cache.Value
type ValueMock struct {
	t minimock.Tester

	funcDelete          func(ctx context.Context, key string) (err error)
	inspectFuncDelete   func(ctx context.Context, key string)
	afterDeleteCounter  uint64
	beforeDeleteCounter uint64
	DeleteMock          mValueMockDelete

	funcGet          func(ctx context.Context, key string) (p1 interface{}, err error)
	inspectFuncGet   func(ctx context.Context, key string)
	afterGetCounter  uint64
	beforeGetCounter uint64
	GetMock          mValueMockGet

	funcPut          func(ctx context.Context, key string, value interface{}) (err error)
	inspectFuncPut   func(ctx context.Context, key string, value interface{})
	afterPutCounter  uint64
	beforePutCounter uint64
	PutMock          mValueMockPut
}

// NewValueMock returns a mock for cache.Value
func NewValueMock(t minimock.Tester) *ValueMock {
	m := &ValueMock{t: t}
	if controller, ok := t.(minimock.MockController); ok {
		controller.RegisterMocker(m)
	}

	m.DeleteMock = mValueMockDelete{mock: m}
	m.DeleteMock.callArgs = []*ValueMockDeleteParams{}

	m.GetMock = mValueMockGet{mock: m}
	m.GetMock.callArgs = []*ValueMockGetParams{}

	m.PutMock = mValueMockPut{mock: m}
	m.PutMock.callArgs = []*ValueMockPutParams{}

	return m
}

type mValueMockDelete struct {
	mock               *ValueMock
	defaultExpectation *ValueMockDeleteExpectation
	expectations       []*ValueMockDeleteExpectation

	callArgs []*ValueMockDeleteParams
	mutex    sync.RWMutex
}

// ValueMockDeleteExpectation specifies expectation struct of the Value.Delete
type ValueMockDeleteExpectation struct {
	mock    *ValueMock
	params  *ValueMockDeleteParams
	results *ValueMockDeleteResults
	Counter uint64
}

// ValueMockDeleteParams contains parameters of the Value.Delete
type ValueMockDeleteParams struct {
	ctx context.Context
	key string
}

// ValueMockDeleteResults contains results of the Value.Delete
type ValueMockDeleteResults struct {
	err error
}

// Expect sets up expected params for Value.Delete
func (mmDelete *mValueMockDelete) Expect(ctx context.Context, key string) *mValueMockDelete {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("ValueMock.Delete mock is already set by Set")
	}

	if mmDelete.defaultExpectation == nil {
		mmDelete.defaultExpectation = &ValueMockDeleteExpectation{}
	}

	mmDelete.defaultExpectation.params = &ValueMockDeleteParams{ctx, key}
	for _, e := range mmDelete.expectations {
		if minimock.Equal(e.params, mmDelete.defaultExpectation.params) {
			mmDelete.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmDelete.defaultExpectation.params)
		}
	}

	return mmDelete
}

// Inspect accepts an inspector function that has same arguments as the Value.Delete
func (mmDelete *mValueMockDelete) Inspect(f func(ctx context.Context, key string)) *mValueMockDelete {
	if mmDelete.mock.inspectFuncDelete != nil {
		mmDelete.mock.t.Fatalf("Inspect function is already set for ValueMock.Delete")
	}

	mmDelete.mock.inspectFuncDelete = f

	return mmDelete
}

// Return sets up results that will be returned by Value.Delete
func (mmDelete *mValueMockDelete) Return(err error) *ValueMock {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("ValueMock.Delete mock is already set by Set")
	}

	if mmDelete.defaultExpectation == nil {
		mmDelete.defaultExpectation = &ValueMockDeleteExpectation{mock: mmDelete.mock}
	}
	mmDelete.defaultExpectation.results = &ValueMockDeleteResults{err}
	return mmDelete.mock
}

//Set uses given function f to mock the Value.Delete method
func (mmDelete *mValueMockDelete) Set(f func(ctx context.Context, key string) (err error)) *ValueMock {
	if mmDelete.defaultExpectation != nil {
		mmDelete.mock.t.Fatalf("Default expectation is already set for the Value.Delete method")
	}

	if len(mmDelete.expectations) > 0 {
		mmDelete.mock.t.Fatalf("Some expectations are already set for the Value.Delete method")
	}

	mmDelete.mock.funcDelete = f
	return mmDelete.mock
}

// When sets expectation for the Value.Delete which will trigger the result defined by the following
// Then helper
func (mmDelete *mValueMockDelete) When(ctx context.Context, key string) *ValueMockDeleteExpectation {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("ValueMock.Delete mock is already set by Set")
	}

	expectation := &ValueMockDeleteExpectation{
		mock:   mmDelete.mock,
		params: &ValueMockDeleteParams{ctx, key},
	}
	mmDelete.expectations = append(mmDelete.expectations, expectation)
	return expectation
}

// Then sets up Value.Delete return parameters for the expectation previously defined by the When method
func (e *ValueMockDeleteExpectation) Then(err error) *ValueMock {
	e.results = &ValueMockDeleteResults{err}
	return e.mock
}

// Delete implements cache.Value
func (mmDelete *ValueMock) Delete(ctx context.Context, key string) (err error) {
	mm_atomic.AddUint64(&mmDelete.beforeDeleteCounter, 1)
	defer mm_atomic.AddUint64(&mmDelete.afterDeleteCounter, 1)

	if mmDelete.inspectFuncDelete != nil {
		mmDelete.inspectFuncDelete(ctx, key)
	}

	mm_params := &ValueMockDeleteParams{ctx, key}

	// Record call args
	mmDelete.DeleteMock.mutex.Lock()
	mmDelete.DeleteMock.callArgs = append(mmDelete.DeleteMock.callArgs, mm_params)
	mmDelete.DeleteMock.mutex.Unlock()

	for _, e := range mmDelete.DeleteMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmDelete.DeleteMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmDelete.DeleteMock.defaultExpectation.Counter, 1)
		mm_want := mmDelete.DeleteMock.defaultExpectation.params
		mm_got := ValueMockDeleteParams{ctx, key}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmDelete.t.Errorf("ValueMock.Delete got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmDelete.DeleteMock.defaultExpectation.results
		if mm_results == nil {
			mmDelete.t.Fatal("No results are set for the ValueMock.Delete")
		}
		return (*mm_results).err
	}
	if mmDelete.funcDelete != nil {
		return mmDelete.funcDelete(ctx, key)
	}
	mmDelete.t.Fatalf("Unexpected call to ValueMock.Delete. %v %v", ctx, key)
	return
}

// DeleteAfterCounter returns a count of finished ValueMock.Delete invocations
func (mmDelete *ValueMock) DeleteAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDelete.afterDeleteCounter)
}

// DeleteBeforeCounter returns a count of ValueMock.Delete invocations
func (mmDelete *ValueMock) DeleteBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDelete.beforeDeleteCounter)
}

// Calls returns a list of arguments used in each call to ValueMock.Delete.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmDelete *mValueMockDelete) Calls() []*ValueMockDeleteParams {
	mmDelete.mutex.RLock()

	argCopy := make([]*ValueMockDeleteParams, len(mmDelete.callArgs))
	copy(argCopy, mmDelete.callArgs)

	mmDelete.mutex.RUnlock()

	return argCopy
}

// MinimockDeleteDone returns true if the count of the Delete invocations corresponds
// the number of defined expectations
func (m *ValueMock) MinimockDeleteDone() bool {
	for _, e := range m.DeleteMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDelete != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		return false
	}
	return true
}

// MinimockDeleteInspect logs each unmet expectation
func (m *ValueMock) MinimockDeleteInspect() {
	for _, e := range m.DeleteMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to ValueMock.Delete with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		if m.DeleteMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to ValueMock.Delete")
		} else {
			m.t.Errorf("Expected call to ValueMock.Delete with params: %#v", *m.DeleteMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDelete != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		m.t.Error("Expected call to ValueMock.Delete")
	}
}

type mValueMockGet struct {
	mock               *ValueMock
	defaultExpectation *ValueMockGetExpectation
	expectations       []*ValueMockGetExpectation

	callArgs []*ValueMockGetParams
	mutex    sync.RWMutex
}

// ValueMockGetExpectation specifies expectation struct of the Value.Get
type ValueMockGetExpectation struct {
	mock    *ValueMock
	params  *ValueMockGetParams
	results *ValueMockGetResults
	Counter uint64
}

// ValueMockGetParams contains parameters of the Value.Get
type ValueMockGetParams struct {
	ctx context.Context
	key string
}

// ValueMockGetResults contains results of the Value.Get
type ValueMockGetResults struct {
	p1  interface{}
	err error
}

// Expect sets up expected params for Value.Get
func (mmGet *mValueMockGet) Expect(ctx context.Context, key string) *mValueMockGet {
	if mmGet.mock.funcGet != nil {
		mmGet.mock.t.Fatalf("ValueMock.Get mock is already set by Set")
	}

	if mmGet.defaultExpectation == nil {
		mmGet.defaultExpectation = &ValueMockGetExpectation{}
	}

	mmGet.defaultExpectation.params = &ValueMockGetParams{ctx, key}
	for _, e := range mmGet.expectations {
		if minimock.Equal(e.params, mmGet.defaultExpectation.params) {
			mmGet.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmGet.defaultExpectation.params)
		}
	}

	return mmGet
}

// Inspect accepts an inspector function that has same arguments as the Value.Get
func (mmGet *mValueMockGet) Inspect(f func(ctx context.Context, key string)) *mValueMockGet {
	if mmGet.mock.inspectFuncGet != nil {
		mmGet.mock.t.Fatalf("Inspect function is already set for ValueMock.Get")
	}

	mmGet.mock.inspectFuncGet = f

	return mmGet
}

// Return sets up results that will be returned by Value.Get
func (mmGet *mValueMockGet) Return(p1 interface{}, err error) *ValueMock {
	if mmGet.mock.funcGet != nil {
		mmGet.mock.t.Fatalf("ValueMock.Get mock is already set by Set")
	}

	if mmGet.defaultExpectation == nil {
		mmGet.defaultExpectation = &ValueMockGetExpectation{mock: mmGet.mock}
	}
	mmGet.defaultExpectation.results = &ValueMockGetResults{p1, err}
	return mmGet.mock
}

//Set uses given function f to mock the Value.Get method
func (mmGet *mValueMockGet) Set(f func(ctx context.Context, key string) (p1 interface{}, err error)) *ValueMock {
	if mmGet.defaultExpectation != nil {
		mmGet.mock.t.Fatalf("Default expectation is already set for the Value.Get method")
	}

	if len(mmGet.expectations) > 0 {
		mmGet.mock.t.Fatalf("Some expectations are already set for the Value.Get method")
	}

	mmGet.mock.funcGet = f
	return mmGet.mock
}

// When sets expectation for the Value.Get which will trigger the result defined by the following
// Then helper
func (mmGet *mValueMockGet) When(ctx context.Context, key string) *ValueMockGetExpectation {
	if mmGet.mock.funcGet != nil {
		mmGet.mock.t.Fatalf("ValueMock.Get mock is already set by Set")
	}

	expectation := &ValueMockGetExpectation{
		mock:   mmGet.mock,
		params: &ValueMockGetParams{ctx, key},
	}
	mmGet.expectations = append(mmGet.expectations, expectation)
	return expectation
}

// Then sets up Value.Get return parameters for the expectation previously defined by the When method
func (e *ValueMockGetExpectation) Then(p1 interface{}, err error) *ValueMock {
	e.results = &ValueMockGetResults{p1, err}
	return e.mock
}

// Get implements cache.Value
func (mmGet *ValueMock) Get(ctx context.Context, key string) (p1 interface{}, err error) {
	mm_atomic.AddUint64(&mmGet.beforeGetCounter, 1)
	defer mm_atomic.AddUint64(&mmGet.afterGetCounter, 1)

	if mmGet.inspectFuncGet != nil {
		mmGet.inspectFuncGet(ctx, key)
	}

	mm_params := &ValueMockGetParams{ctx, key}

	// Record call args
	mmGet.GetMock.mutex.Lock()
	mmGet.GetMock.callArgs = append(mmGet.GetMock.callArgs, mm_params)
	mmGet.GetMock.mutex.Unlock()

	for _, e := range mmGet.GetMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.p1, e.results.err
		}
	}

	if mmGet.GetMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmGet.GetMock.defaultExpectation.Counter, 1)
		mm_want := mmGet.GetMock.defaultExpectation.params
		mm_got := ValueMockGetParams{ctx, key}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmGet.t.Errorf("ValueMock.Get got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmGet.GetMock.defaultExpectation.results
		if mm_results == nil {
			mmGet.t.Fatal("No results are set for the ValueMock.Get")
		}
		return (*mm_results).p1, (*mm_results).err
	}
	if mmGet.funcGet != nil {
		return mmGet.funcGet(ctx, key)
	}
	mmGet.t.Fatalf("Unexpected call to ValueMock.Get. %v %v", ctx, key)
	return
}

// GetAfterCounter returns a count of finished ValueMock.Get invocations
func (mmGet *ValueMock) GetAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGet.afterGetCounter)
}

// GetBeforeCounter returns a count of ValueMock.Get invocations
func (mmGet *ValueMock) GetBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGet.beforeGetCounter)
}

// Calls returns a list of arguments used in each call to ValueMock.Get.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmGet *mValueMockGet) Calls() []*ValueMockGetParams {
	mmGet.mutex.RLock()

	argCopy := make([]*ValueMockGetParams, len(mmGet.callArgs))
	copy(argCopy, mmGet.callArgs)

	mmGet.mutex.RUnlock()

	return argCopy
}

// MinimockGetDone returns true if the count of the Get invocations corresponds
// the number of defined expectations
func (m *ValueMock) MinimockGetDone() bool {
	for _, e := range m.GetMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGet != nil && mm_atomic.LoadUint64(&m.afterGetCounter) < 1 {
		return false
	}
	return true
}

// MinimockGetInspect logs each unmet expectation
func (m *ValueMock) MinimockGetInspect() {
	for _, e := range m.GetMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to ValueMock.Get with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetCounter) < 1 {
		if m.GetMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to ValueMock.Get")
		} else {
			m.t.Errorf("Expected call to ValueMock.Get with params: %#v", *m.GetMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGet != nil && mm_atomic.LoadUint64(&m.afterGetCounter) < 1 {
		m.t.Error("Expected call to ValueMock.Get")
	}
}

type mValueMockPut struct {
	mock               *ValueMock
	defaultExpectation *ValueMockPutExpectation
	expectations       []*ValueMockPutExpectation

	callArgs []*ValueMockPutParams
	mutex    sync.RWMutex
}

// ValueMockPutExpectation specifies expectation struct of the Value.Put
type ValueMockPutExpectation struct {
	mock    *ValueMock
	params  *ValueMockPutParams
	results *ValueMockPutResults
	Counter uint64
}

// ValueMockPutParams contains parameters of the Value.Put
type ValueMockPutParams struct {
	ctx   context.Context
	key   string
	value interface{}
}

// ValueMockPutResults contains results of the Value.Put
type ValueMockPutResults struct {
	err error
}

// Expect sets up expected params for Value.Put
func (mmPut *mValueMockPut) Expect(ctx context.Context, key string, value interface{}) *mValueMockPut {
	if mmPut.mock.funcPut != nil {
		mmPut.mock.t.Fatalf("ValueMock.Put mock is already set by Set")
	}

	if mmPut.defaultExpectation == nil {
		mmPut.defaultExpectation = &ValueMockPutExpectation{}
	}

	mmPut.defaultExpectation.params = &ValueMockPutParams{ctx, key, value}
	for _, e := range mmPut.expectations {
		if minimock.Equal(e.params, mmPut.defaultExpectation.params) {
			mmPut.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmPut.defaultExpectation.params)
		}
	}

	return mmPut
}

// Inspect accepts an inspector function that has same arguments as the Value.Put
func (mmPut *mValueMockPut) Inspect(f func(ctx context.Context, key string, value interface{})) *mValueMockPut {
	if mmPut.mock.inspectFuncPut != nil {
		mmPut.mock.t.Fatalf("Inspect function is already set for ValueMock.Put")
	}

	mmPut.mock.inspectFuncPut = f

	return mmPut
}

// Return sets up results that will be returned by Value.Put
func (mmPut *mValueMockPut) Return(err error) *ValueMock {
	if mmPut.mock.funcPut != nil {
		mmPut.mock.t.Fatalf("ValueMock.Put mock is already set by Set")
	}

	if mmPut.defaultExpectation == nil {
		mmPut.defaultExpectation = &ValueMockPutExpectation{mock: mmPut.mock}
	}
	mmPut.defaultExpectation.results = &ValueMockPutResults{err}
	return mmPut.mock
}

//Set uses given function f to mock the Value.Put method
func (mmPut *mValueMockPut) Set(f func(ctx context.Context, key string, value interface{}) (err error)) *ValueMock {
	if mmPut.defaultExpectation != nil {
		mmPut.mock.t.Fatalf("Default expectation is already set for the Value.Put method")
	}

	if len(mmPut.expectations) > 0 {
		mmPut.mock.t.Fatalf("Some expectations are already set for the Value.Put method")
	}

	mmPut.mock.funcPut = f
	return mmPut.mock
}

// When sets expectation for the Value.Put which will trigger the result defined by the following
// Then helper
func (mmPut *mValueMockPut) When(ctx context.Context, key string, value interface{}) *ValueMockPutExpectation {
	if mmPut.mock.funcPut != nil {
		mmPut.mock.t.Fatalf("ValueMock.Put mock is already set by Set")
	}

	expectation := &ValueMockPutExpectation{
		mock:   mmPut.mock,
		params: &ValueMockPutParams{ctx, key, value},
	}
	mmPut.expectations = append(mmPut.expectations, expectation)
	return expectation
}

// Then sets up Value.Put return parameters for the expectation previously defined by the When method
func (e *ValueMockPutExpectation) Then(err error) *ValueMock {
	e.results = &ValueMockPutResults{err}
	return e.mock
}

// Put implements cache.Value
func (mmPut *ValueMock) Put(ctx context.Context, key string, value interface{}) (err error) {
	mm_atomic.AddUint64(&mmPut.beforePutCounter, 1)
	defer mm_atomic.AddUint64(&mmPut.afterPutCounter, 1)

	if mmPut.inspectFuncPut != nil {
		mmPut.inspectFuncPut(ctx, key, value)
	}

	mm_params := &ValueMockPutParams{ctx, key, value}

	// Record call args
	mmPut.PutMock.mutex.Lock()
	mmPut.PutMock.callArgs = append(mmPut.PutMock.callArgs, mm_params)
	mmPut.PutMock.mutex.Unlock()

	for _, e := range mmPut.PutMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmPut.PutMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmPut.PutMock.defaultExpectation.Counter, 1)
		mm_want := mmPut.PutMock.defaultExpectation.params
		mm_got := ValueMockPutParams{ctx, key, value}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmPut.t.Errorf("ValueMock.Put got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmPut.PutMock.defaultExpectation.results
		if mm_results == nil {
			mmPut.t.Fatal("No results are set for the ValueMock.Put")
		}
		return (*mm_results).err
	}
	if mmPut.funcPut != nil {
		return mmPut.funcPut(ctx, key, value)
	}
	mmPut.t.Fatalf("Unexpected call to ValueMock.Put. %v %v %v", ctx, key, value)
	return
}

// PutAfterCounter returns a count of finished ValueMock.Put invocations
func (mmPut *ValueMock) PutAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmPut.afterPutCounter)
}

// PutBeforeCounter returns a count of ValueMock.Put invocations
func (mmPut *ValueMock) PutBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmPut.beforePutCounter)
}

// Calls returns a list of arguments used in each call to ValueMock.Put.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmPut *mValueMockPut) Calls() []*ValueMockPutParams {
	mmPut.mutex.RLock()

	argCopy := make([]*ValueMockPutParams, len(mmPut.callArgs))
	copy(argCopy, mmPut.callArgs)

	mmPut.mutex.RUnlock()

	return argCopy
}

// MinimockPutDone returns true if the count of the Put invocations corresponds
// the number of defined expectations
func (m *ValueMock) MinimockPutDone() bool {
	for _, e := range m.PutMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.PutMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterPutCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcPut != nil && mm_atomic.LoadUint64(&m.afterPutCounter) < 1 {
		return false
	}
	return true
}

// MinimockPutInspect logs each unmet expectation
func (m *ValueMock) MinimockPutInspect() {
	for _, e := range m.PutMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to ValueMock.Put with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.PutMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterPutCounter) < 1 {
		if m.PutMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to ValueMock.Put")
		} else {
			m.t.Errorf("Expected call to ValueMock.Put with params: %#v", *m.PutMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcPut != nil && mm_atomic.LoadUint64(&m.afterPutCounter) < 1 {
		m.t.Error("Expected call to ValueMock.Put")
	}
}

// MinimockFinish checks that all mocked methods have been called the expected number of times
func (m *ValueMock) MinimockFinish() {
	if !m.minimockDone() {
		m.MinimockDeleteInspect()

		m.MinimockGetInspect()

		m.MinimockPutInspect()
		m.t.FailNow()
	}
}

// MinimockWait waits for all mocked methods to be called the expected number of times
func (m *ValueMock) MinimockWait(timeout mm_time.Duration) {
	timeoutCh := mm_time.After(timeout)
	for {
		if m.minimockDone() {
			return
		}
		select {
		case <-timeoutCh:
			m.MinimockFinish()
			return
		case <-mm_time.After(10 * mm_time.Millisecond):
		}
	}
}

func (m *ValueMock) minimockDone() bool {
	done := true
	return done &&
		m.MinimockDeleteDone() &&
		m.MinimockGetDone() &&
		m.MinimockPutDone()
}
